VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FindBar 
   Caption         =   "Find"
   ClientHeight    =   60
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11865
   OleObjectBlob   =   "FindBar.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FindBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Slim Find Toolbar     ! VBE size (Height=22) slimmed due to toolbar removal

' WIP Problems
'- Wildcards: only first and last instance are found, if at all
'- Highlight: not working at all

' unlike F&R dialog
'- Format options are either-or: only explicit selected options found not all instaces that also include them
'- UF doesn't save searchfield and options


' No TitleBar, thus manual Close Button + Mouse Drag on UF's empty space
Private m_sngDownX As Single
Private m_sngDownY As Single
Private Sub UserForm_Initialize()
    HideBar Me                      ' Remove Border and Title Bar: code in module Myn_Userform
End Sub
Private Sub CloseUF_Click()
    Unload Me 'Me.Hide              ' Manual Close Button
End Sub
Private Sub UserForm_MouseDown(ByVal Button As Integer, ByVal Shift As Integer, ByVal x As Single, ByVal Y As Single)
    If Button = 1 Then
        m_sngDownX = x
        m_sngDownY = Y
    End If
End Sub
Private Sub UserForm_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal x As Single, ByVal Y As Single)
    If Button And 1 Then
        Me.Left = Me.Left + (x - m_sngDownX)
        Me.Top = Me.Top + (Y - m_sngDownY)
    End If
End Sub

' Search
Private Sub Up_Click()
    Dim Rng As Range
    options.DefaultHighlightColorIndex = wdYellow
    ' search from cursor position
        If Len(Selection) > 1 Then
            Set Rng = Selection.Range
        Else
            Set Rng = ActiveDocument.Range(ActiveDocument.Range.Start, Selection.End)
        End If
    ' Finding
    With Rng.Find
    ' delete previous options and formats
        .MatchCase = False
        .Highlight = False
        .MatchWildcards = False
        .MatchWholeWord = False
        .ClearFormatting
    ' check options
        .Format = True
        .MatchCase = MatchCase.value
        .MatchWildcards = UseWildcards.value
        .Highlight = HighlightAll.value
        .MatchWholeWord = WholeWords.value
    ' check formats
        .Font.Bold = FormatBold.value
        .Font.Italic = FormatItalic.value
        .Font.Underline = FormatUnderline.value
        .Font.StrikeThrough = FormatStrike.value
    ' search input
        .Text = SearchField.Text
    ' find backwards
        .Forward = False
        .Wrap = wdFindContinue              ' wdFindStop: ends search upon reaching doc beginning/end, wdFindContinue cycles doc eternally
        .Execute FindText:=SearchField.Text
        .Parent.Select
    ' Nothing Found Temp Message
        If .Execute Then ' .Found = False without else / .Found
        Else
'            CreateObject("WScript.Shell").Popup "Nothing Found", 1, " "  ' # in seconds: max 1 sec
            FindBarNone.Show                                              ' # in ms: set to 500 ms = 0.5 sec
        End If
    End With
End Sub
Private Sub Down_Click()
    Dim Rng As Range
    options.DefaultHighlightColorIndex = wdYellow
    ' search from cursor position
        If Len(Selection) > 1 Then
            Set Rng = Selection.Range
        Else
            Set Rng = ActiveDocument.Range(Selection.Start, ActiveDocument.Range.End)
        End If
    ' Finding
    With Rng.Find
    ' delete previous options and formats
        .MatchCase = False
        .Highlight = False
        .MatchWildcards = False
        .MatchWholeWord = False
        .ClearFormatting
    ' check options
        .Format = True
        .MatchCase = MatchCase.value
        .MatchWildcards = UseWildcards.value
        .Highlight = HighlightAll.value
        .MatchWholeWord = WholeWords.value
    ' check formats
        .Font.Bold = FormatBold.value
        .Font.Italic = FormatItalic.value
        .Font.Underline = FormatUnderline.value
        .Font.StrikeThrough = FormatStrike.value
    ' search input
        .Text = SearchField.Text
    ' find forward
        .Forward = True
        .Wrap = wdFindContinue 'Stop
        .Execute FindText:=SearchField.Text
        .Parent.Select
    ' Nothing Found Temp Message
        If .Execute Then
        Else
            FindBarNone.Show
        End If
    End With
End Sub

' ____________________________________________________________________________
'
' inclusive Format options
'If FormatBold.value = True Then
'    .Font.Bold
'    .Font.Bold .Font.Italic
'    .Font.Bold .Font.Italic + .Font.Underline
'    .Font.Bold .Font.Italic + .Font.StrikeThrough
'    .Font.Bold .Font.Underline
'    .Font.Bold .Font.Underline + .Font.StrikeThrough
'    .Font.Bold .Font.StrikeThrough
'End If
'If FormatItalic.value = True Then
'    .Font.Italic
'    .Font.Italic .Font.Bold
'    .Font.Italic .Font.Bold + .Font.Underline
'    .Font.Italic .Font.Bold + .Font.StrikeThrough
'    .Font.Italic .Font.Underline
'    .Font.Italic .Font.Underline + .Font.StrikeThrough
'    .Font.Italic .Font.StrikeThrough
'End If
'If FormatUnderline.value = True Then
'    .Font.Underline
'    .Font.Underline .Font.Italic
'    .Font.Underline .Font.Italic + .Font.Bold
'    .Font.Underline .Font.Italic + .Font.StrikeThrough
'    .Font.Underline .Font.Bold
'    .Font.Underline .Font.Bold + .Font.StrikeThrough
'    .Font.Underline .Font.StrikeThrough
'End If
'If FormatStrike.value = True Then
'    .Font.StrikeThrough
'    .Font.StrikeThrough .Font.Italic
'    .Font.StrikeThrough .Font.Italic + .Font.Underline
'    .Font.StrikeThrough .Font.Italic + .Font.Bold
'    .Font.StrikeThrough .Font.Underline
'    .Font.StrikeThrough .Font.Underline + .Font.Bold
'    .Font.StrikeThrough .Font.Bold
'End If
' ____________________________________________________________________________
'
'' save/keep Options to F&R Dialog: search field is automatically ported upon succesful search with last instance found (match case relevance)
'Private Sub MatchCase_Click()
'    Call Userform_Initialize
'    With Selection.Find: .MatchCase = Not .MatchCase: End With
'End Sub
'Private Sub HighlightAll_Click()
'    Call Userform_Initialize
'    With Selection.Find: .Highlight = Not .Highlight: End With
'End Sub
'Private Sub UseWildcards_Click()
'    Call Userform_Initialize
'    With Selection.Find: .MatchWildcards = Not .MatchWildcards: End With
'End Sub
'Private Sub WholeWords_Click()
'    Call Userform_Initialize
'    With Selection.Find: .MatchWholeWord = Not .MatchWholeWord: End With
'End Sub
'Private Sub FormatBold_Click()
'    Call Userform_Initialize
'    With Selection.Find: .Font.Bold = wdToggle: End With
'End Sub
'Private Sub FormatItalic_Click()
'    Call Userform_Initialize
'    With Selection.Find: .Font.Italic = wdToggle: End With
'End Sub
'Private Sub FormatStrike_Click()
'    Call Userform_Initialize
'    With Selection.Find: .Font.StrikeThrough = wdToggle: End With
'End Sub
'Private Sub FormatUnderline_Click()
'    Call Userform_Initialize
'    With Selection.Find
'        If .Font.Underline = wdUnderlineSingle Then
'            .Font.Underline = wdUnderlineNone
'        Else
'            .Font.Underline = wdUnderlineSingle
'        End If
'    End With
'End Sub
