Attribute VB_Name = "Myn_Userform"
' Removes UF Close Buttons by adding the following to a userform code
'    Private Sub UserForm_Initialize()
'        RemoveCloseButton Me
'    End Sub
' Removing the TitleBar altogether removes close button + drag'n'reposition .: need those buttons on the form ! for splash screens
'    Private Sub UserForm_Initialize()
'        HideBar Me
'    End Sub
' Close Button code: Unload Me 'Me.Hide
' _________________________________________________________________________________________________________________________________


Private Const GWL_STYLE As Long = -16
Private Const HTCAPTION = 2&
Private Const WM_NCLBUTTONDOWN = &HA1&
Private Const WS_BORDER = &H800000
Private Const WS_CAPTION = WS_BORDER 'Or WS_DLGFRAME
Private Const WS_DLGFRAME = &H400000
Private Const WS_SYSMENU As Long = &H80000

#If VBA7 Then   ' (Office 2010 or later)
    Private Declare PtrSafe Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As LongPtr
'    Public Declare PtrSafe Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
'    Public Declare PtrSafe Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
'    Public Declare PtrSafe Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
#If Win64 Then
    Private Declare PtrSafe Function GetWindowLong Lib "user32" Alias "GetWindowLongPtrA" (ByVal hWnd As LongPtr, ByVal nIndex As Long) As LongPtr
    Private Declare PtrSafe Function SetWindowLong Lib "user32" Alias "SetWindowLongPtrA" (ByVal hWnd As LongPtr, ByVal nIndex As Long, ByVal dwNewLong As LongPtr) As LongPtr
#Else
    Private Declare PtrSafe Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As LongPtr, ByVal nIndex As Long) As LongPtr
    Private Declare PtrSafe Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As LongPtr, ByVal nIndex As Long, ByVal dwNewLong As LongPtr) As LongPtr
    Public Declare PtrSafe Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
#End If
#Else  ' VBA 6(Office 2003 or earlier)
    Private Declare Function FindWindow Lib "User32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
'    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
    Private Declare Function GetWindowLong Lib "User32" Alias "GetWindowLongA" (ByVal HWND As Long, ByVal nIndex As Long) As Long
    Private Declare Function SetWindowLong Lib "User32" Alias "SetWindowLongA" (ByVal HWND As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
'    Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
'    Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    Public Declare Function DrawMenuBar Lib "User32" (ByVal HWND As Long) As Long
    Private Declare Function SendMessage Lib "User32" Alias "SendMessageA" (ByVal HWND As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
    Private Declare Sub ReleaseCapture Lib "User32" ()
#End If

Public Sub RemoveCloseButton(frm As Object)
    #If VBA7 Then
        Dim lStyle As LongPtr, lFrmHandle As LongPtr
    #Else
        Dim lStyle As Long, lFrmHandle As Long
    #End If
    lFrmHandle = FindWindow("ThunderDFrame", frm.Caption)
    lStyle = GetWindowLong(lFrmHandle, GWL_STYLE)
    lStyle = lStyle And Not WS_SYSMENU
    SetWindowLong lFrmHandle, GWL_STYLE, lStyle
End Sub

Sub HideBar(frm As Object)
    Dim Style As Long, Menu As Long, hWndForm As Long
    hWndForm = FindWindow("ThunderDFrame", frm.Caption)
    Style = GetWindowLong(hWndForm, &HFFF0)
    Style = Style And Not &HC00000
    SetWindowLong hWndForm, &HFFF0, Style
    DrawMenuBar hWndForm
End Sub

'Sub HandleDragMove(HWND As Long)
'    Call ReleaseCapture
'    Call SendMessage(HWND, WM_NCLBUTTONDOWN, HTCAPTION, 0&)
'End Sub
'Function Setup(objForm As Object) As Long
'    Setup = FindWindow("ThunderDFrame", objForm.Caption)
'    SetWindowLong Setup, GWL_STYLE, GetWindowLong(Setup, GWL_STYLE) And Not WS_CAPTION
'End Function
' + on UF: recolors the titlebar to green
'Private gHWND As Long
'Private Sub Label1_MouseMove(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
'    If Button = 1 Then HandleDragMove gHWND
'End Sub
'Private Sub UserForm_Initialize()
'    gHWND = Setup(Me)
'End Sub
'Private Sub UserForm_Click()
'    Unload Me
'End Sub


' FindToolbar for Macro button
    Sub FindToolbar()
        Application.ScreenUpdating = False
        Dim FB As FindBar: Set FB = FindBar
        Load FB: FB.Show vbModeless
    ' StartUp Position
        FB.StartUpPosition = 0                                      ' enables repostion
        FB.Top = Application.Top + Application.UsableHeight / 4.8   ' rel to Window: below 5 TBs ontop of ruler/below 4 TBs+Ruler
        FB.Left = Application.Left                                  ' rel to Window: Left Side
lbl_Exit:
        Application.ScreenUpdating = True
        Exit Sub
    End Sub